//+------------------------------------------------------------------+
//|                                                       RSX_MA.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#property link      "http://metatrader.50webs.com/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 clrGold
#property indicator_color2 clrRed
#property strict

//---- input parameters
extern int Lengh                       = 21; // RSX period
int        CountBars                   = 700;
int        MaType                      = MODE_SMMA;
extern int MaPeriod                    = 5; // MA period
extern double LevelUp = 0.230; // Level up
extern double LevelDown = -0.230; // Level down
extern bool   arrowsVisible    = false;             // Arrows visible?
extern string arrowsIdentifier = "rsx+ma1";         // Unique ID for arrows
extern double arrowsUpperGap   = 1.0;               // Upper arrow gap
extern double arrowsLowerGap   = 1.0;               // Lower arrow gap
extern color  arrowsUpColor    = clrDodgerBlue;     // Up arrow color
extern color  arrowsDnColor    = clrRed;            // Down arrow color
extern int    arrowsUpCode     = 241;               // Up arrow code
extern int    arrowsDnCode     = 242;               // Down arrow code
extern int    arrowsSize       = 1;                 // Arrows size
extern bool   alertsOn         = false;             // Turn alerts on?
extern bool   alertsOnCurrent  = false;             // Alerts on currnt (still opened) bar?
extern bool   alertsMessage    = true;              // Alerts should show pop-up message?
extern bool   alertsSound      = false;             // Alerts should play alert sound?
extern bool   alertsPushNotif  = false;             // Alerts should send push notification?
extern bool   alertsEmail      = false;             // Alerts should send email?
//---- buffers
double rsx[];
double ExtMapBuffer1[],arrows[];

int shift,r,w,counted_bars,T0,T1;
datetime Tnew;
//----
double v4,v8,v10,v14,v18,v20,v0C,v1C,v8A,minuse;
double F28,F30,F38,F40,F48,F50,F58,F60,F68,F70,F78,F80,JRSX;
double f0,f28,f30,f38,f40,f48,f50,f58,f60,f68,f70,f78,f80,Kg,Hg;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,rsx);
   
  
   SetIndexStyle(1,DRAW_LINE);

   SetIndexBuffer(1,ExtMapBuffer1);
   SetIndexBuffer(2,arrows);
   SetIndexEmptyValue(1,0.0);

   
   IndicatorShortName("RSX_MA");
   SetIndexDrawBegin(0,Bars-CountBars);
   IndicatorDigits((int)MarketInfo(Symbol(),MODE_DIGITS));
   SetLevelValue(0,LevelUp);
   SetLevelValue(1,LevelDown);
   
//----  
   if (Lengh-1>=5) w=Lengh-1; else w=5; Kg=3/(Lengh+2.0); Hg=1.0-Kg;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    k=0;
   
   counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>Lengh) shift=Bars-counted_bars-1;
   else shift=Bars-Lengh-1;
//----
   Tnew=Time[shift+1];
   //----   -------
   if((Tnew!=T0)&&(shift<Bars-Lengh-1))
     {
      if (Tnew==T1)
        {
         f28=F28; f30=F30; f38=F38; f40=F40; f48=F48; f50=F50;
         f58=F58; f60=F60; f68=F68; f70=F70; f78=F78; f80=F80;
        } else return(-1);
     }
//----
   if (Lengh-1>=5)w=Lengh-1;else w=5; Kg=3/(Lengh+2.0); Hg=1.0-Kg;
   while(shift>=0)
     {
      //+-------------------+
      if (r==0){r=1; k=0;}
      else
        {
         //----
         if (r>=w) r=w+1; else r=r+1;
         v8=Close[shift]-Close[shift+1]; v8A=MathAbs(v8);
         //----  V14 ------
         f28=Hg  * f28 + Kg  *  v8;
         f30=Kg  * f28 + Hg  * f30;
         v0C=1.5 * f28 - 0.5 * f30;
         f38=Hg  * f38 + Kg  * v0C;
         f40=Kg  * f38 + Hg  * f40;
         v10=1.5 * f38 - 0.5 * f40;
         f48=Hg  * f48 + Kg  * v10;
         f50=Kg  * f48 + Hg  * f50;
         v14=1.5 * f48 - 0.5 * f50;
         //----  V20 ------
         f58=Hg  * f58 + Kg  * v8A;
         f60=Kg  * f58 + Hg  * f60;
         v18=1.5 * f58 - 0.5 * f60;
         f68=Hg  * f68 + Kg  * v18;
         f70=Kg  * f68 + Hg  * f70;
         v1C=1.5 * f68 - 0.5 * f70;
         f78=Hg  * f78 + Kg  * v1C;
         f80=Kg  * f78 + Hg  * f80;
         v20=1.5 * f78 - 0.5 * f80;
         //----
         if ((r<=w) && (v8!= 0)) k=1;
         if ((r==w) && (k==0)) r=0;
        }//-----
      if ((r>w)&&(v20>0.0000000001))
      {
        v4=(v14/v20+1.0)*50.0;
      /*if(v4>100.0)
      v4=100.0;
      if(v4<0.0)
      v4=0.0;*/
      }
      else 
      v4=50.0;
      rsx[shift]=(v4/50)-1;
      if (shift==1)
        {
         T1=(int)Time[1];T0=(int)Time[0];
         F28=f28; F30=f30; F38=f38; F40=f40; F48=f48; F50=f50;
         F58=f58; F60=f60; F68=f68; F70=f70; F78=f78; F80=f80;
        }
      
           
   shift--;
   ArraySetAsSeries(rsx,true);
   }
      
   for(int j=CountBars-MaPeriod; j>=0; j--) 
   {
      ExtMapBuffer1[j] = iMAOnArray(rsx,Bars,MaPeriod,0,MaType,j);
      arrows[j]=0;
         if (rsx[j]>LevelUp   && rsx[j]<ExtMapBuffer1[j]) arrows[j] = -1;
         if (rsx[j]<LevelDown && rsx[j]>ExtMapBuffer1[j]) arrows[j] =  1;
         if (arrowsVisible)
         {
            string lookFor = arrowsIdentifier+":"+(string)Time[j]; ObjectDelete(lookFor);            
            if (arrows[j] != arrows[j+1])
            {
               if (arrows[j] == 1) drawArrow(j,arrowsUpColor,arrowsUpCode,false);
               if (arrows[j] ==-1) drawArrow(j,arrowsDnColor,arrowsDnCode, true);
            }
        }
   }
   manageAlerts();
   return(0);
  }

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (arrows[whichBar] != arrows[whichBar+1])
      {
         if (arrows[whichBar] ==  1) doAlert(whichBar,"up");
         if (arrows[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" rsx ma signal "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(_Symbol+"r sx ma",message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //

      datetime time = Time[i];
      ObjectCreate(name,OBJ_ARROW,0,time,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_WIDTH,arrowsSize);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}